/*
  mergemod.h
  
  This file is part of mergemem by Philipp Richter & Philipp Reisner

  mergemem is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.
  
  mergemem is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with mergemem; see the file COPYING.  If not, write to
  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

*/

/* parameter values needed by mergemem */
struct mergemod_struct 
{
  int pid1;
  int pid2;
  unsigned long addr1;
  unsigned long addr2;
};

/* return values issued by mergemem() */
#define MERGEMEM_SUCCESS 0
#define MERGEMEM_NOTASK1 1
#define MERGEMEM_NOTASK2 2
#define MERGEMEM_NOPAGE1 3
#define MERGEMEM_NOPAGE2 4
#define MERGEMEM_NOTEQUAL 5
#define MERGEMEM_ALREADYSH 6
#define MERGEMEM_MOREMAP 7
#define MERGEMEM_ILLREQ 100

/* if pid2==0 a checksum of pid1's page at the virtual address addr1 is
 * calculated and returned in addr2!! and returns MERGEMEM_SUCCESS
 */
/* if pid1!=0 && pid2!=0 the and the return value is MERGEMEM_SUCCESS the
 * two pages where merged, and in pid1 the pid of the process wich
 * page was kept is returned! 
 */
